import xml.dom.minidom
import copy
import os
import wx
import ast   #convert strings into list   u'[1027, 1057]'  ->> [1027,1057]

import GlobalVariables as gv
import dataStruct

def ReadIniFile(ini_filename):
  inifile = open(ini_filename)
  DOMTree = xml.dom.minidom.parse(inifile)
  data = DOMTree.documentElement
  images = data.getElementsByTagName('FactionImages')
  if (images != []):
    dataStruct.factionBitmapPath['Aquan'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Aquan'))
    dataStruct.factionBitmapPath['Sorylian'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Sorylian'))
    dataStruct.factionBitmapPath['Terran'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Terran'))
    dataStruct.factionBitmapPath['Hawker Industries'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Hawker'))
    dataStruct.factionBitmapPath['Dindrenzi'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Dindrenzi'))
    dataStruct.factionBitmapPath['Directorate'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Directorate'))
    dataStruct.factionBitmapPath["Ba'Kash"] = os.path.join(gv.faction_images_folder, images[0].getAttribute('BaKash'))
    dataStruct.factionBitmapPath['Kedorian'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Kedorian'))
    dataStruct.factionBitmapPath['Relthoza'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Relthoza'))
    dataStruct.factionBitmapPath['Rense System Navy'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Rense'))
    dataStruct.factionBitmapPath['Ryushi'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Ryushi'))
    dataStruct.factionBitmapPath['Tarakian'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Tarakian'))
    dataStruct.factionBitmapPath['Terquai'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Terquai'))
    dataStruct.factionBitmapPath['Veydreth'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Veydreth'))
    dataStruct.factionBitmapPath['Works Raptor'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Works'))
    dataStruct.factionBitmapPath['Xelocian'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Xelocian'))
    dataStruct.factionBitmapPath['OSO Corsairs'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Corsairs'))
    dataStruct.factionBitmapPath['OSO Omnidyne'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Omnidyne'))
    dataStruct.factionBitmapPath['Oroshan'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Oroshan'))
    dataStruct.factionBitmapPath['Pathogen'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Pathogen'))
    dataStruct.factionBitmapPath['STL Syndicate'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Syndicate'))
    dataStruct.factionBitmapPath['STL Traders'] = os.path.join(gv.faction_images_folder, images[0].getAttribute('Traders'))
  return
  

def SaveFleetData(filename, fleetRoster, fleetIndex=None):
  """fleetIndex is the roster list index if we are saving a single fleet out of the list.
     fleetRoster should always be the master list of all fleets
     """
  if (not fleetRoster):
    fleet = dataStruct.FleetRecord()
    
  if (fleetIndex):
    fleetList = []
    fleetList.append(fleetRoster[fleetIndex])
  else:
    fleetList = fleetRoster
    
  savefile = file(filename, 'w')
  savefile.write("<?xml version='1.0' encoding='utf-8'?>\n")
  savefile.write("<Roster>\n")
  for fleet in fleetList:
    savefile.write('\t<Fleet>\n')
    savefile.write('\t\t<FleetData MFV="{0}" CFV="{1}" coreFaction="{2}" fleetName="{3}" restrictToCore="{4}" restrictToInventory="{5}" includeMercenaries="{6}" includeNaturalAllies="{7}"/>\n'.format(fleet.MFV, fleet.CFV, fleet.coreFaction, fleet.fleetName, fleet.restrictToCore, fleet.restrictToInventory, fleet.includeMercenaries, fleet.includeNaturalAllies))
    if (fleet.notes == ""):
      savefile.write('\t\t<FleetNotes></FleetNotes>\n')
    else:
      savefile.write('\t\t<FleetNotes>{0}</FleetNotes>\n'.format(fleet.notes))
    for squadron in fleet.squadronList:
      savefile.write('\t\t<squadron squadronSize="{0}" squadronName="{1}" squadronTier="{2}" >\n'.format(squadron.size, squadron.name, squadron.tier))
      savefile.write('\t\t\t<ship shipID="{0}" shipName="{1}" currentCost="{2}" >\n'.format(squadron.ship.index, squadron.ship.shipName, squadron.ship.currentCost))
      if (squadron.ship.imageCustomFilename):
        savefile.write('\t\t\t\t<CustomImage filename="{0}" />\n'.format(squadron.ship.imageCustomFilename))
      savefile.write('\t\t\t\t<stats DR="{0}" CR="{1}" HP="{2}" MV="{3}" TL="{4}" CP="{5}" AP="{6}" PD="{7}" SR="{8}" MN="{9}" WC="{10}" />\n'.format(squadron.ship.DR,squadron.ship.CR,squadron.ship.HP,squadron.ship.MV,squadron.ship.TL,squadron.ship.CP,squadron.ship.AP,squadron.ship.PD,squadron.ship.SR,squadron.ship.MN,squadron.ship.WC))
      for srs in squadron.ship.currentSRS:
        savefile.write('\t\t\t\t<currentSRS srsType="{0}" srsNumWings="{1}" />\n'.format(srs.srsType, srs.numWings))
      for mar in squadron.ship.currentMAR:
        savefile.write('\t\t\t\t<mar marNumber="{0}" marValueReqd="{1}" marInt1="{2}" marInt2="{3}" marStr1="{4}" marStr2="{5}" marIndex="{6}" />\n'.format(mar.marNumber, mar.valueRequired, mar.intValue1, mar.intValue2, mar.strValue1, mar.strValue2, mar.marIndex))
      for upg in squadron.ship.currentUpgrades:
        savefile.write('\t\t\t\t<upgrade upgIndex="{0}" upgInt1="{1}" upgInt2="{2}" upgStr1="{3}" upgCost="{4}" upgText="{5}" />\n'.format(upg.index, upg.intValue1, upg.intValue2, upg.stringValue, upg.cost, upg.text))
      for hardpoint in squadron.ship.currentHardpoints:
        savefile.write('\t\t\t\t<hardpoint hpIndex="{0}" hpNumAvailable="{1}" hpNumSelected="{2}" hpDescription="{3}" hpCost="{4}" hpInt1="{5}" hpInt2="{6}" hpInt3="{7}" hpStr1="{8}" hpStr2="{9}" />\n'.format(hardpoint.index, hardpoint.numAvailable, hardpoint.numSelected, hardpoint.description, hardpoint.cost, hardpoint.intValue1, hardpoint.intValue2, hardpoint.intValue3, hardpoint.strValue1, hardpoint.strValue2))
      if (squadron.ship.currentAccompaniment):
        savefile.write('\t\t\t\t<accompaniment shipID="{0}" accompIndex="{1}" numShips="{2}" numAllowed="{3}" />\n'.format(squadron.ship.currentAccompaniment.shipIndex, squadron.ship.currentAccompaniment.accompIndex,squadron.ship.currentAccompaniment.numSelected, squadron.ship.currentAccompaniment.numAllowed))
        if (squadron.ship.currentAccompaniment.ship.imageCustomFilename):
          savefile.write('\t\t\t\t<CustomImage filename="{0}" />\n'.format(squadron.ship.currentAccompaniment.ship.imageCustomFilename))
        for srs in squadron.ship.currentAccompaniment.ship.currentSRS:
          savefile.write('\t\t\t\t<accompanimentSRS srsType="{0}" srsNumWings="{1}" />\n'.format(srs.srsType, srs.numWings))
        for mar in squadron.ship.currentAccompaniment.ship.currentMAR:
          savefile.write('\t\t\t\t<accompanimentMar marNumber="{0}" marValueReqd="{1}" marInt1="{2}" marInt2="{3}" marStr1="{4}" marStr2="{5}" marIndex="{6}" />\n'.format(mar.marNumber, mar.valueRequired, mar.intValue1, mar.intValue2, mar.strValue1, mar.strValue2, mar.marIndex))
        for upg in squadron.ship.currentAccompaniment.ship.currentUpgrades:
          savefile.write('\t\t\t\t<accompanimentUpgrade upgIndex="{0}" upgInt1="{1}" upgInt2="{2}" upgStr1="{3}" upgCost="{4}" upgText="{5}" />\n'.format(upg.index, upg.intValue1, upg.intValue2, upg.stringValue, upg.cost, upg.text))
        for hardpoint in squadron.ship.currentAccompaniment.ship.currentHardpoints:
          savefile.write('\t\t\t\t<hardpoint hpIndex="{0}" hpNumAvailable="{1}" hpNumSelected="{2}" hpDescription="{3}" hpCost="{4}" hpInt1="{5}" hpInt2="{6}" hpInt3="{7}" hpStr1="{8}" hpStr2="{9}" />\n'.format(hardpoint.index, hardpoint.numAvailable, hardpoint.numSelected, hardpoint.description, hardpoint.cost, hardpoint.intValue1, hardpoint.intValue2, hardpoint.intValue3, hardpoint.strValue1, hardpoint.strValue2))
      savefile.write('\t\t\t</ship>\n')
      if (squadron.heavyCruiser):
        savefile.write('\t\t\t<heavyCruiser shipID="{0}" shipName="{1}" currentCost="{2}" >\n'.format(squadron.heavyCruiser.index, squadron.heavyCruiser.shipName, squadron.heavyCruiser.currentCost))
        if (squadron.heavyCruiser.imageCustomFilename):
          savefile.write('\t\t\t\t<CustomImage filename="{0}" />\n'.format(squadron.heavyCruiser.imageCustomFilename))
        for srs in squadron.heavyCruiser.currentSRS:
          savefile.write('\t\t\t\t<currentSRS srsType="{0}" srsNumWings="{1}" />\n'.format(srs.srsType, srs.numWings))
        for mar in squadron.heavyCruiser.currentMAR:
          savefile.write('\t\t\t\t<mar marNumber="{0}" marValueReqd="{1}" marInt1="{2}" marInt2="{3}" marStr1="{4}" marStr2="{5}" marIndex="{6}" />\n'.format(mar.marNumber, mar.valueRequired, mar.intValue1, mar.intValue2, mar.strValue1, mar.strValue2, mar.marIndex))
        for upg in squadron.heavyCruiser.currentUpgrades:
          savefile.write('\t\t\t\t<upgrade upgIndex="{0}" upgInt1="{1}" upgInt2="{2}" upgStr1="{3}" upgCost="{4}" upgText="{5}" />\n'.format(upg.index, upg.intValue1, upg.intValue2, upg.stringValue, upg.cost, upg.text))
        for hardpoint in squadron.heavyCruiser.currentHardpoints:
          savefile.write('\t\t\t\t<hardpoint hpIndex="{0}" hpNumAvailable="{1}" hpNumSelected="{2}" hpDescription="{3}" hpCost="{4}" hpInt1="{5}" hpInt2="{6}" hpInt3="{7}" hpStr1="{8}" hpStr2="{9}" />\n'.format(hardpoint.index, hardpoint.numAvailable, hardpoint.numSelected, hardpoint.description, hardpoint.cost, hardpoint.intValue1, hardpoint.intValue2, hardpoint.intValue3, hardpoint.strValue1, hardpoint.strValue2))
        savefile.write('\t\t\t</heavyCruiser>\n')
      savefile.write('\t\t</squadron>\n')
    savefile.write('\t</Fleet>\n')
  savefile.write('</Roster>')
  savefile.close()
  return

def SaveMarData(filename=None):
  if (not filename):
    return False
  datafile = file(filename,'w')
  datafile.write("<?xml version='1.0' encoding='utf-8'?>\n")
  datafile.write('<MAR_data>\n')
  mar = dataStruct.MarRecord()
  for mar in gv.MarList:
    datafile.write('\t<MAR>\n')
    datafile.write('\t<MAR_Number>%s</MAR_Number>\n'% mar.marNumber)
    datafile.write('\t<MAR_Name>%s</MAR_Name>\n'% mar.marName)
    if (mar.valueRequired):
      datafile.write('\t<MAR_ValueRequired>True</MAR_ValueRequired>\n')
    datafile.write('\t<MAR_Text>%s</MAR_Text>\n'% mar.marText)
    datafile.write('\t<MAR_Summary>%s</MAR_Summary>\n'% mar.marSummary)
    if (mar.intValue1):
      datafile.write('\t<MAR_intValue1>%s</MAR_Value1>\n' % mar.intValue1)
    if (mar.intValue2):
      datafile.write('\t<MAR_intValue2>%s</MAR_Value2>\n' % mar.intValue2)
    if (mar.strValue1):
      datafile.write('\t<MAR_strValue1>%s</MAR_Value1>\n' % mar.strValue1)
    if (mar.strValue2):
      datafile.write('\t<MAR_strValue2>%s</MAR_Value2>\n' % mar.strValue2)
    datafile.write('\t</MAR>\n')
  datafile.write('</MAR_data>\n')
  datafile.close()
  return True

def SaveFleetCompositionData(filename, fleetCompositions):

  if (not filename):
    return
  
  savefile = open(filename, "w")
  savefile.write("<?xml version='1.0' encoding='utf-8'?>\n")
  savefile.write("<FleetComposition>\n")
  for factionID,fleetComp in fleetCompositions.iteritems():
    savefile.write('\t<Fleet name="{0}">\n'.format(factionID))
    savefile.write('\t\t<TierLimits minPatrolTier1="{0}" maxPatrolTier1="{1}" minPatrolTier2="{2}" maxPatrolTier2="{3}" minPatrolTier3="{4}" maxPatrolTier3="{5}" minBattleTier1="{6}" maxBattleTier1="{7}" minBattleTier2="{8}" maxBattleTier2="{9}" minBattleTier3="{10}" maxBattleTier3="{11}" minGrandTier1="{12}" maxGrandTier1="{13}" minGrandTier2="{14}" maxGrandTier2="{15}" minGrandTier3="{16}" maxGrandTier3="{17}" />\n'.format(fleetComp['minPatrolTier1'],fleetComp['maxPatrolTier1'],fleetComp['minPatrolTier2'],fleetComp['maxPatrolTier2'],fleetComp['minPatrolTier3'],fleetComp['maxPatrolTier3'],fleetComp['minBattleTier1'],fleetComp['maxBattleTier1'],fleetComp['minBattleTier2'],fleetComp['maxBattleTier2'],fleetComp['minBattleTier3'],fleetComp['maxBattleTier3'],fleetComp['minGrandTier1'],fleetComp['maxGrandTier1'],fleetComp['minGrandTier2'],fleetComp['maxGrandTier2'],fleetComp['minGrandTier3'],fleetComp['maxGrandTier3'],))
    savefile.write('\t\t<PatrolTier1 ')
    for key,value in fleetComp['patrolTier1'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t\t<PatrolTier2 ')
    for key,value in fleetComp['patrolTier2'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t\t<PatrolTier3 ')
    for key,value in fleetComp['patrolTier3'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    
    savefile.write('\t\t<BattleTier1 ')
    for key,value in fleetComp['battleTier1'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t\t<BattleTier2 ')
    for key,value in fleetComp['battleTier2'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t\t<BattleTier3 ')
    for key,value in fleetComp['battleTier3'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    
    savefile.write('\t\t<GrandTier1 ')
    for key,value in fleetComp['grandTier1'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t\t<GrandTier2 ')
    for key,value in fleetComp['grandTier2'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t\t<GrandTier3 ')
    for key,value in fleetComp['grandTier3'].iteritems():
      savefile.write('{0}="{1}" '.format(key, value))
    savefile.write(' />\n')
    savefile.write('\t</Fleet>\n')
  savefile.write("</FleetComposition>")
  

def ReadFleetCompositionData(filename):
  #fleetCompositions = []
  if (not filename):
    return False
  
  try:
    DOMTree = xml.dom.minidom.parse(filename)
  except Exception, errorMsg:
    return errorMsg
  
  fleetList = DOMTree.documentElement
  fleets = fleetList.getElementsByTagName('Fleet')
  fleetComp = dataStruct.fleetRaces
  
  for fleet in fleets:
    faction = fleet.getAttribute("name")
    limits = fleet.getElementsByTagName('TierLimits')
    fleetComp[faction]['minPatrolTier1'] = int(limits[0].getAttribute('minPatrolTier1'))
    fleetComp[faction]['minPatrolTier2'] = int(limits[0].getAttribute('minPatrolTier2'))
    fleetComp[faction]['minPatrolTier3'] = int(limits[0].getAttribute('minPatrolTier3'))
    fleetComp[faction]['maxPatrolTier1'] = int(limits[0].getAttribute('maxPatrolTier1'))
    fleetComp[faction]['maxPatrolTier2'] = int(limits[0].getAttribute('maxPatrolTier2'))
    fleetComp[faction]['maxPatrolTier3'] = int(limits[0].getAttribute('maxPatrolTier3'))
    
    fleetComp[faction]['minBattleTier1'] = int(limits[0].getAttribute('minBattleTier1'))
    fleetComp[faction]['minBattleTier2'] = int(limits[0].getAttribute('minBattleTier2'))
    fleetComp[faction]['minBattleTier3'] = int(limits[0].getAttribute('minBattleTier3'))
    fleetComp[faction]['maxBattleTier1'] = int(limits[0].getAttribute('maxBattleTier1'))
    fleetComp[faction]['maxBattleTier2'] = int(limits[0].getAttribute('maxBattleTier2'))
    fleetComp[faction]['maxBattleTier3'] = int(limits[0].getAttribute('maxBattleTier3'))

    fleetComp[faction]['minGrandTier1'] = int(limits[0].getAttribute('minGrandTier1'))
    fleetComp[faction]['minGrandTier2'] = int(limits[0].getAttribute('minGrandTier2'))
    fleetComp[faction]['minGrandTier3'] = int(limits[0].getAttribute('minGrandTier3'))
    fleetComp[faction]['maxGrandTier1'] = int(limits[0].getAttribute('maxGrandTier1'))
    fleetComp[faction]['maxGrandTier2'] = int(limits[0].getAttribute('maxGrandTier2'))
    fleetComp[faction]['maxGrandTier3'] = int(limits[0].getAttribute('maxGrandTier3'))
    
    
    fleetComp[faction]['patrolTier1'] = copy.deepcopy(dataStruct.nullFleet)
    fleetComp[faction]['patrolTier2'] = copy.deepcopy(dataStruct.nullFleet)
    fleetComp[faction]['patrolTier3'] = copy.deepcopy(dataStruct.nullFleet)
    
    fleetComp[faction]['battleTier1'] = copy.deepcopy(dataStruct.nullFleet)
    fleetComp[faction]['battleTier2'] = copy.deepcopy(dataStruct.nullFleet)
    fleetComp[faction]['battleTier3'] = copy.deepcopy(dataStruct.nullFleet)

    fleetComp[faction]['grandTier1'] = copy.deepcopy(dataStruct.nullFleet)
    fleetComp[faction]['grandTier2'] = copy.deepcopy(dataStruct.nullFleet)
    fleetComp[faction]['grandTier3'] = copy.deepcopy(dataStruct.nullFleet)
    
    pt = fleet.getElementsByTagName('PatrolTier1')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['patrolTier1'][key] = int(pt[0].getAttribute(key))
    
    pt = fleet.getElementsByTagName('PatrolTier2')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['patrolTier2'][key] = int(pt[0].getAttribute(key))
      
    pt = fleet.getElementsByTagName('PatrolTier3')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['patrolTier3'][key] = int(pt[0].getAttribute(key))
      
    pt = fleet.getElementsByTagName('BattleTier1')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['battleTier1'][key] = int(pt[0].getAttribute(key))
    
    pt = fleet.getElementsByTagName('BattleTier2')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['battleTier2'][key] = int(pt[0].getAttribute(key))
      
    pt = fleet.getElementsByTagName('BattleTier3')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['battleTier3'][key] = int(pt[0].getAttribute(key))
      
    pt = fleet.getElementsByTagName('GrandTier1')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['grandTier1'][key] = int(pt[0].getAttribute(key))
    
    pt = fleet.getElementsByTagName('GrandTier2')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['grandTier2'][key] = int(pt[0].getAttribute(key))
      
    pt = fleet.getElementsByTagName('GrandTier3')
    for key, value in pt[0]._attrs.iteritems():
      fleetComp[faction]['grandTier3'][key] = int(pt[0].getAttribute(key))
  gv.FleetComposition = fleetComp
  return True

def ReadShipClassData(filename, listArray):
  if (not filename):
    return False
  try:
    DOMTree = xml.dom.minidom.parse(filename)
  except Exception, errorMsg:
    return errorMsg
  
  shipList = DOMTree.documentElement
  shipClasses = shipList.getElementsByTagName('shipClass')
  
  ship = dataStruct.ShipRecord()
  for ship in shipClasses:
    newRecord = dataStruct.ShipRecord()
    xmldata = ship.getElementsByTagName('shipIndex')
    newRecord.index = int(xmldata[0].childNodes[0].data)
    
    xmldata = ship.getElementsByTagName('faction')
    if (xmldata[0].childNodes != []):
      newRecord.faction = xmldata[0].childNodes[0].data

    xmldata = ship.getElementsByTagName('deleted_ship')
    if (xmldata[0].childNodes[0].data == 'True'):
      newRecord.deleted_ship = True
    else:
      newRecord.deleted_ship = False

    xmldata = ship.getElementsByTagName('className')
    if (xmldata[0].childNodes != []):
      newRecord.className = xmldata[0].childNodes[0].data

    xmldata = ship.getElementsByTagName('designation')
    if (xmldata[0].childNodes != []):
      newRecord.designation = xmldata[0].childNodes[0].data
      
    xmldata = ship.getElementsByTagName('baseCost')
    if (xmldata[0].childNodes != []):
      newRecord.baseCost = int(xmldata[0].childNodes[0].data)
      newRecord.currentCost = newRecord.baseCost  

    xmldata = ship.getElementsByTagName('secondaryCost')
    if (xmldata != [] and xmldata[0].childNodes != []):
      newRecord.secondaryCost = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('squadronMin')
    if (xmldata[0].childNodes != []):
      newRecord.squadronSizeMin = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('squadronMax')
    if (xmldata[0].childNodes != []):
      newRecord.squadronSizeMax = int(xmldata[0].childNodes[0].data)
    
    xmldata = ship.getElementsByTagName('classSize')
    if (xmldata[0].childNodes != []):
      newRecord.classSize = xmldata[0].childNodes[0].data
    
    xmldata = ship.getElementsByTagName('source')
    if (xmldata[0].childNodes != []):
      newRecord.source = xmldata[0].childNodes[0].data

    xmldata = ship.getElementsByTagName('DR')
    if (xmldata[0].childNodes != []):
      newRecord.DR = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('CR')
    if (xmldata[0].childNodes != []):
      newRecord.CR = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('HP')
    if (xmldata[0].childNodes != []):
      newRecord.HP = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('MV')
    if (xmldata[0].childNodes != []):
      newRecord.MV = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('TL')
    if (xmldata[0].childNodes != []):
      newRecord.TL = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('CP')
    if (xmldata[0].childNodes != []):
      newRecord.CP = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('AP')
    if (xmldata[0].childNodes != []):
      newRecord.AP = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('PD')
    if (xmldata[0].childNodes != []):
      newRecord.PD = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('SR')
    if (xmldata[0].childNodes != []):
      newRecord.SR = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('MN')
    if (xmldata[0].childNodes != []):
      newRecord.MN = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('WC')
    if (xmldata[0].childNodes != []):
      newRecord.WC = int(xmldata[0].childNodes[0].data)
      
    #all ships have two SRS records, regardless of WC
    newRecord.currentSRS.append(dataStruct.srsRecord())
    newRecord.currentSRS.append(dataStruct.srsRecord())
    
    xmldata = ship.getElementsByTagName('CloakingField')
    if (xmldata[0].childNodes[0].data == 'True'):
      newRecord.cloakingField = True
    else:
      newRecord.cloakingField = False

    xmldata = ship.getElementsByTagName('notes')
    if (xmldata != []) and (xmldata[0].childNodes != []):
      newRecord.notes = xmldata[0].childNodes[0].data
    else:
      newRecord.notes = ''

    xmldata = ship.getElementsByTagName('image')
    if (xmldata[0].childNodes == []):
      newRecord.imageFilename = gv.defaultImage
    else:
      newRecord.imageFilename = xmldata[0].childNodes[0].data

    xmldata = ship.getElementsByTagName('weaponsArray')
    if (xmldata != []):
      for weapon in xmldata[0].getElementsByTagName('weapon'):
        newWeapon = dataStruct.WeaponRecord()
        newWeapon.weaponName = weapon.getAttribute('weaponName')
        newWeapon.category = weapon.getAttribute('category')
        newWeapon.weaponType = weapon.getAttribute('weaponType')
        newWeapon.arcDirection = weapon.getAttribute('arcDirection')
        newWeapon.arcRestriction = weapon.getAttribute('arcRestriction')
        newWeapon.rb1 = int(weapon.getAttribute('rb1'))
        newWeapon.rb2 = int(weapon.getAttribute('rb2'))
        newWeapon.rb3 = int(weapon.getAttribute('rb3'))
        newWeapon.rb4 = int(weapon.getAttribute('rb4'))
        if (weapon.hasAttribute('hardpoint')):
          newWeapon.hardpoint = True
        newWeapon.rangeIncrement = int(weapon.getAttribute('rangeIncrement'))
        newRecord.weapons.append(newWeapon)
    newRecord.currentWeapons = copy.deepcopy(newRecord.weapons)
    
    xmldata = ship.getElementsByTagName('maxHardpoints')
    newRecord.maxHardPoints = int(xmldata[0].childNodes[0].data)

    xmldata = ship.getElementsByTagName('availableHardpoints')
    if (xmldata != []):
      for hardpoint in xmldata[0].getElementsByTagName('hardpoint'):
        newHardpoint = dataStruct.HardpointRecord()
        newHardpoint.index = int(hardpoint.getAttribute('index'))
        newHardpoint.numAvailable = int(hardpoint.getAttribute('numAvailable'))
        newHardpoint.description = hardpoint.getAttribute('description')
        newHardpoint.cost = int(hardpoint.getAttribute('cost'))
        if (hardpoint.getAttribute('intValue1') != ''):
          newHardpoint.intValue1 = int(hardpoint.getAttribute('intValue1'))
        if (hardpoint.getAttribute('intValue2') != ''):
          newHardpoint.intValue2 = int(hardpoint.getAttribute('intValue2'))
        if (hardpoint.getAttribute('intValue3') != ''):
          newHardpoint.intValue3 = int(hardpoint.getAttribute('intValue3'))
        newHardpoint.strValue1 = hardpoint.getAttribute('strValue1')
        newHardpoint.strValue2 = hardpoint.getAttribute('strValue2')
        newRecord.availableHardPoints.append(newHardpoint)

    xmldata = ship.getElementsByTagName('marList')
    if (xmldata != []):
      for mar in xmldata[0].getElementsByTagName('mar'):
        newMAR = dataStruct.MarRecord()
        newMAR.marNumber = int(mar.getAttribute('number'))
        for marItem in gv.MarList:
          if (marItem.marNumber == newMAR.marNumber):
            newMAR = copy.deepcopy(marItem)
        if (newMAR.valueRequired):
          newMAR.intValue1 = mar.getAttribute('intValue1')
          newMAR.intValue2 = mar.getAttribute('intValue2')
          newMAR.strValue1 = mar.getAttribute('strValue1')
          newMAR.strValue2 = mar.getAttribute('strValue2')
          #adjust MAR text based on the marNumber
          if (newMAR.marNumber == 3):
            newMAR.marName = 'Ambush {0}'.format(newMAR.intValue1)
          elif (newMAR.marNumber == 20):
            newMAR.marName = 'Energy Transfer ({0}, {1})'.format(newMAR.strValue1, newMAR.intValue1)
          elif (newMAR.marNumber == 28):
            newMAR.marName = 'Minefields ({0},{1} AD)'.format(newMAR.intValue1, newMAR.intValue2)
          elif (newMAR.marNumber == 36):
            newMAR.marName = 'Reinforced ({0})'.format(newMAR.strValue1)
          elif (newMAR.marNumber == 37):
            newMAR.marName = 'Retractable Plating ({0})'.format(newMAR.strValue1)
          elif (newMAR.marNumber == 43):
            newMAR.marName = 'Shield Projector ({0})'.format(newMAR.intValue1)
          elif (newMAR.marNumber == 44):
            newMAR.marName = 'Shunt Matrix ({0})'.format(newMAR.intValue1)
          elif (newMAR.marNumber == 46):
            newMAR.marName = 'Split Fire ({0})'.format(newMAR.strValue1)
          elif (newMAR.marNumber == 58):
            newMAR.marName = 'Planetfall ({0})'.format(newMAR.intValue1)
          elif (newMAR.marNumber == 59):
            newMAR.marName = 'Improved Shunt Matrix ({0})'.format(newMAR.intValue1)
          elif (newMAR.marNumber == 60):
            newMAR.marName = 'Energy Locus ({0})'.format(newMAR.intValue1)
        newRecord.MAR.append(newMAR)
    newRecord.currentMAR = copy.deepcopy(newRecord.MAR)
    
    xmldata = ship.getElementsByTagName('accompanimentAvailable')
    if (xmldata != []):
      for escort in xmldata[0].getElementsByTagName('escort'):
        newEscort = dataStruct.AccompanimentRecord()
        newEscort.numAllowed = int(escort.getAttribute('escortShipMax'))
        newEscort.shipIndex = int(escort.getAttribute('escortShipIndex'))
        newRecord.accompanimentIncluded.append(newEscort)
    
    xmldata = ship.getElementsByTagName('upgradesList')
    if (xmldata != []):
      for upgrade in xmldata[0].getElementsByTagName('upgrade'):
        newUpgrade = dataStruct.UpgradeRecord()
        newUpgrade.index = int(upgrade.getAttribute('index'))
        newUpgrade.cost = int(upgrade.getAttribute('cost'))
        xor = upgrade.getAttribute('xor')
        if (xor == ''):
          newUpgrade.xor = []
        else:
          newUpgrade.xor = ast.literal_eval(xor)
        color = upgrade.getAttribute('color')
        if (color == ''):
          newUpgrade.color = None
        else:
          (r,g,b,a) = ast.literal_eval(color)
          newUpgrade.color = wx.Colour(r,g,b,a)
        newUpgrade.text = dataStruct.upgrades[newUpgrade.index]
        newRecord.upgrades.append(newUpgrade)

    listArray.append(newRecord)
  #go back through the list and assign shipRecords to accompaniment slots
  accomp = dataStruct.AccompanimentRecord()
  for ship in listArray:
    for accomp in ship.accompanimentIncluded:
      accomp.ship = copy.deepcopy(gv.ShipClassList[accomp.shipIndex])
  return True

def ReadFleetData(fleetDataFile):
  if (not fleetDataFile):
    return False
  else:
    fleetList = []
    try:
      DOMTree = xml.dom.minidom.parse(fleetDataFile)
    except Exception, errorMsg:
      return errorMsg
    
    shipList = DOMTree.documentElement
    Fleets = shipList.getElementsByTagName('Fleet')
    if (Fleets == []):
      #no fleets, exit
      return []
    else:
      data = dataStruct.FleetRecord()
      for data in Fleets:
        x = data.getElementsByTagName('FleetData')
        fleet = dataStruct.FleetRecord()
        fleet.fleetName = x[0].getAttribute('fleetName')
        fleet.coreFaction = x[0].getAttribute('coreFaction')
        if (x[0].getAttribute('restrictToCore') == 'True'):
          fleet.restrictToCore = True
        else:
          fleet.restrictToCore = False
        if (x[0].getAttribute('restrictToInventory') == 'True'):
          fleet.restrictToInventory = True
        else:
          fleet.restrictToInventory = False
        if (x[0].getAttribute('includeMercenaries') == 'True'):
          fleet.includeMercenaries = True
        else:
          fleet.includeMercenaries = False
        if (x[0].getAttribute('includeNaturalAllies') == 'True'):
          fleet.includeNaturalAllies = True
        else:
          fleet.includeNaturalAllies = False
        fleet.CFV = int(x[0].getAttribute('CFV'))
        fleet.SetFleetMFV(int(x[0].getAttribute('MFV')))
        xmldata = data.getElementsByTagName('FleetNotes')
        if (xmldata != []) and (xmldata[0].childNodes != []):
          fleet.notes = xmldata[0].childNodes[0].data
        squadrons = data.getElementsByTagName('squadron')
        if (squadrons != []):
          for sq in squadrons:
            squadron = dataStruct.squadronRecord()
            squadron.size = int(sq.getAttribute('squadronSize'))
            squadron.name = sq.getAttribute('squadronName')
            squadron.tier = int(sq.getAttribute('squadronTier'))
            ships = sq.getElementsByTagName('ship')
            if (ships != []):
              for ship in ships:
                squadron.ship = copy.deepcopy(gv.ShipClassList[int(ship.getAttribute('shipID'))])
                squadron.ship.shipName = ship.getAttribute('shipName')
                squadron.ship.currentCost = int(ship.getAttribute('currentCost'))
                squadron.ship.tier = squadron.tier
                SRS = ship.getElementsByTagName('currentSRS')
                if (SRS != []) and (len(SRS) == 2):
                  squadron.ship.currentSRS[0].srsType = SRS[0].getAttribute('srsType')
                  squadron.ship.currentSRS[0].SetWingCount(int(SRS[0].getAttribute('srsNumWings')))
                  squadron.ship.currentSRS[1].srsType = SRS[1].getAttribute('srsType')
                  squadron.ship.currentSRS[1].SetWingCount(int(SRS[1].getAttribute('srsNumWings')))
                  
                customImage = ship.getElementsByTagName('CustomImage')
                if (customImage != []):
                  squadron.ship.imageCustomFilename = customImage[0].getAttribute('filename')
                STATS = ship.getElementsByTagName('stats')
                if (STATS != []):
                  squadron.ship.DR = int(STATS[0].getAttribute('DR'))
                  squadron.ship.CR = int(STATS[0].getAttribute('CR'))
                  squadron.ship.HP = int(STATS[0].getAttribute('HP'))
                  squadron.ship.MV = int(STATS[0].getAttribute('MV'))
                  squadron.ship.TL = int(STATS[0].getAttribute('TL'))
                  squadron.ship.CP = int(STATS[0].getAttribute('CP'))
                  squadron.ship.AP = int(STATS[0].getAttribute('AP'))
                  squadron.ship.PD = int(STATS[0].getAttribute('PD'))
                  squadron.ship.SR = int(STATS[0].getAttribute('SR'))
                  squadron.ship.MN = int(STATS[0].getAttribute('MN'))
                  squadron.ship.WC = int(STATS[0].getAttribute('WC'))
                MAR = ship.getElementsByTagName('mar')
                squadron.ship.currentMAR = []  #reset the copied ship MARS
                for mar in MAR:
                  marEntry = dataStruct.MarRecord()
                  marEntry.marNumber = mar.getAttribute('marNumber')
                  valueRequired = mar.getAttribute('marValueReqd')
                  if (valueRequired == 'True'):
                    marEntry.valueRequired = True
                  else:
                    marEntry.valueRequired = False
                  marEntry.marIndex = mar.getAttribute('marIndex')
                  marEntry = copy.deepcopy(gv.MarList[int(mar.getAttribute('marIndex'))])
                  marEntry.intValue1 = int(mar.getAttribute('marInt1'))
                  marEntry.intValue2 = int(mar.getAttribute('marInt2'))
                  marEntry.strValue1 = mar.getAttribute('marStr1')
                  marEntry.strValue2 = mar.getAttribute('marStr2')
                  squadron.ship.currentMAR.append(marEntry)
                squadron.ship.ApplyMarValues()
                HARDPOINTS = ship.getElementsByTagName('hardpoint')
                for hardpoint in HARDPOINTS:
                  hpEntry = dataStruct.HardpointRecord()
                  hpEntry.index = int(hardpoint.getAttribute('hpIndex'))
                  hpEntry.numAvailable = int(hardpoint.getAttribute('hpNumAvailable'))
                  hpEntry.numSelected = int(hardpoint.getAttribute('hpNumSelected'))
                  hpEntry.description = hardpoint.getAttribute('hpDescription')
                  hpEntry.cost = int(hardpoint.getAttribute('hpCost'))
                  hpEntry.intValue1 = int(hardpoint.getAttribute('hpInt1'))
                  hpEntry.intValue2 = int(hardpoint.getAttribute('hpInt2'))
                  hpEntry.intValue3 = int(hardpoint.getAttribute('hpInt3'))
                  hpEntry.strValue1 = hardpoint.getAttribute('hpStr1')
                  hpEntry.strValue2 = hardpoint.getAttribute('hpStr2')
                  squadron.ship.currentHardpoints.append(hpEntry)
                squadron.ship.ApplyHardpoints()
                UPGRADES = ship.getElementsByTagName('upgrade')
                for upgrade in UPGRADES:
                  upg = dataStruct.UpgradeRecord()
                  upg.index = int(upgrade.getAttribute('upgIndex'))
                  upg.cost = int(upgrade.getAttribute('upgCost'))
                  upg.intValue1 = int(upgrade.getAttribute('upgInt1'))
                  upg.intValue2 = int(upgrade.getAttribute('upgInt2'))
                  upg.stringValue = upgrade.getAttribute('upgStr1')
                  upg.text = upgrade.getAttribute('upgText')
                  squadron.ship.currentUpgrades.append(upg)
                squadron.ship.ApplyUpgrades()
                ACCOMPANIMENT = ship.getElementsByTagName('accompaniment')
                for accomp in ACCOMPANIMENT:
                  acc = dataStruct.AccompanimentRecord()
                  acc.numAllowed = int(accomp.getAttribute('numAllowed'))
                  acc.numSelected = int(accomp.getAttribute('numShips'))
                  acc.shipIndex = int(accomp.getAttribute('shipID'))
                  acc.accompIndex = int(accomp.getAttribute('accompIndex'))
                  acc.ship = copy.deepcopy(gv.ShipClassList[acc.shipIndex])
                  squadron.ship.currentAccompaniment = acc
                  
                if (squadron.ship.currentAccompaniment != None):
                  customImage = accomp.getElementsByTagName('CustomImage')
                  if (customImage != []):
                    squadron.ship.currentAccompaniment.ship.imageCustomFilename = customImage[0].getAttribute('filename')
                  
                  accompSRS = sq.getElementsByTagName('accompanimentSRS')
                  if (accompSRS != []) and (len(accompSRS) == 2):
                    squadron.ship.currentAccompaniment.ship.currentSRS[0].srsType = SRS[0].getAttribute('srsType')
                    squadron.ship.currentAccompaniment.ship.currentSRS[0].SetWingCount(int(SRS[0].getAttribute('srsNumWings')))
                    squadron.ship.currentAccompaniment.ship.currentSRS[1].srsType = SRS[1].getAttribute('srsType')
                    squadron.ship.currentAccompaniment.ship.currentSRS[1].SetWingCount(int(SRS[1].getAttribute('srsNumWings')))
                        
                  accompMAR = sq.getElementsByTagName('accompanimentMar')
                  squadron.ship.currentAccompaniment.ship.currentMAR = []
                  for mar in accompMAR:
                    marEntry = dataStruct.MarRecord()
                    marEntry.marIndex = mar.getAttribute('marIndex')
                    marEntry.marNumber = mar.getAttribute('marNumber')
                    marEntry = copy.deepcopy(gv.MarList[int(mar.getAttribute('marIndex'))])
                    marEntry.intValue1 = int(mar.getAttribute('marInt1'))
                    marEntry.intValue2 = int(mar.getAttribute('marInt2'))
                    marEntry.strValue1 = mar.getAttribute('marStr1')
                    marEntry.strValue2 = mar.getAttribute('marStr2')
                    squadron.ship.currentAccompaniment.ship.currentMAR.append(marEntry)
                  squadron.ship.currentAccompaniment.ship.ApplyMarValues()
                  
                  accompUPGRADES = sq.getElementsByTagName('accompanimentUpgrade')
                  for upgrade in accompUPGRADES:
                    upg = dataStruct.UpgradeRecord()
                    upg.index = int(upgrade.getAttribute('upgIndex'))
                    upg.cost = int(upgrade.getAttribute('upgCost'))
                    upg.intValue1 = int(upgrade.getAttribute('upgInt1'))
                    upg.intValue2 = int(upgrade.getAttribute('upgInt2'))
                    upg.stringValue = upgrade.getAttribute('upgStr1')
                    upg.text = upgrade.getAttribute('upgText')
                    squadron.ship.currentAccompaniment.ship.currentUpgrades.append(upg)
                  squadron.ship.currentAccompaniment.ship.ApplyUpgrades()
                  
                  accompHARDPOINTS = sq.getElementsByTagName('accompanimentHardpoint')
                  for hardpoint in accompHARDPOINTS:
                    hpEntry = dataStruct.HardpointRecord()
                    hpEntry.index = int(hardpoint.getAttribute('hpIndex'))
                    hpEntry.numAvailable = int(hardpoint.getAttribute('hpNumAvailable'))
                    hpEntry.numSelected = int(hardpoint.getAttribute('hpNumSelected'))
                    hpEntry.description = hardpoint.getAttribute('hpDescription')
                    hpEntry.cost = int(hardpoint.getAttribute('hpCost'))
                    hpEntry.intValue1 = int(hardpoint.getAttribute('hpInt1'))
                    hpEntry.intValue2 = int(hardpoint.getAttribute('hpInt2'))
                    hpEntry.intValue3 = int(hardpoint.getAttribute('hpInt3'))
                    hpEntry.strValue1 = hardpoint.getAttribute('hpStr1')
                    hpEntry.strValue2 = hardpoint.getAttribute('hpStr2')
                    squadron.ship.currentAccompaniment.ship.currentHardpoints.append(hpEntry)
                    squadron.ship.currentAccompaniment.ship.ApplyHardpoints()
                  
            heavyCruiser = sq.getElementsByTagName('heavyCruiser')
            if (heavyCruiser != []):
              squadron.heavyCruiser = copy.deepcopy(gv.ShipClassList[int(heavyCruiser[0].getAttribute('shipID'))])
              squadron.heavyCruiser.shipName = heavyCruiser[0].getAttribute('shipName')
              squadron.heavyCruiser.currentCost = int(heavyCruiser[0].getAttribute('currentCost'))
              squadron.heavyCruiser.tier = squadron.tier
              customImage = heavyCruiser[0].getElementsByTagName('CustomImage')
              if (customImage != []):
                squadron.heavyCruiser.imageCustomFilename = customImage[0].getAttribute('filename')
                
              SRS = heavyCruiser[0].getElementsByTagName('currentSRS')
              if (SRS != []) and (len(SRS) == 2):
                squadron.ship.currentSRS[0].srsType = SRS[0].getAttribute('srsType')
                squadron.ship.currentSRS[0].SetWingCount(int(SRS[0].getAttribute('srsNumWings')))
                squadron.ship.currentSRS[1].srsType = SRS[1].getAttribute('srsType')
                squadron.ship.currentSRS[1].SetWingCount(int(SRS[1].getAttribute('srsNumWings')))
                
              MAR = heavyCruiser[0].getElementsByTagName('mar')
              squadron.heavyCruiser.currentMAR = []
              for mar in MAR:
                marEntry = dataStruct.MarRecord()
                marEntry.marIndex = mar.getAttribute('marIndex')
                marEntry.marNumber = mar.getAttribute('marNumber')
                marEntry = copy.deepcopy(gv.MarList[int(mar.getAttribute('marIndex'))])
                marEntry.intValue1 = int(mar.getAttribute('marInt1'))
                marEntry.intValue2 = int(mar.getAttribute('marInt2'))
                marEntry.strValue1 = mar.getAttribute('marStr1')
                marEntry.strValue2 = mar.getAttribute('marStr2')
                squadron.heavyCruiser.currentMAR.append(marEntry)
              squadron.heavyCruiser.ApplyMarValues()
              
              UPGRADES = heavyCruiser[0].getElementsByTagName('upgrade')
              for upgrade in UPGRADES:
                upg = dataStruct.UpgradeRecord()
                upg.index = int(upgrade.getAttribute('upgIndex'))
                upg.cost = int(upgrade.getAttribute('upgCost'))
                upg.intValue1 = int(upgrade.getAttribute('upgInt1'))
                upg.intValue2 = int(upgrade.getAttribute('upgInt2'))
                upg.stringValue = upgrade.getAttribute('upgStr1')
                upg.text = upgrade.getAttribute('upgText')
                squadron.heavyCruiser.currentUpgrades.append(upg)
              squadron.heavyCruiser.ApplyUpgrades()
              
              HARDPOINTS = heavyCruiser[0].getElementsByTagName('hardpoint')
              for hardpoint in HARDPOINTS:
                hpEntry = dataStruct.HardpointRecord()
                hpEntry.index = int(hardpoint.getAttribute('hpIndex'))
                hpEntry.numAvailable = int(hardpoint.getAttribute('hpNumAvailable'))
                hpEntry.numSelected = int(hardpoint.getAttribute('hpNumSelected'))
                hpEntry.description = hardpoint.getAttribute('hpDescription')
                hpEntry.cost = int(hardpoint.getAttribute('hpCost'))
                hpEntry.intValue1 = int(hardpoint.getAttribute('hpInt1'))
                hpEntry.intValue2 = int(hardpoint.getAttribute('hpInt2'))
                hpEntry.intValue3 = int(hardpoint.getAttribute('hpInt3'))
                hpEntry.strValue1 = hardpoint.getAttribute('hpStr1')
                hpEntry.strValue2 = hardpoint.getAttribute('hpStr2')
                squadron.heavyCruiser.currentHardpoints.append(hpEntry)
              squadron.heavyCruiser.ApplyHardpoints()
            fleet.AddSquadron(squadron)
        fleetList.append(fleet)

  return fleetList


def ReadInventoryData(filename):
  if (not filename):
    return False
  try:
    DOMTree = xml.dom.minidom.parse(filename)
  except Exception, errorMsg:
    return errorMsg
  
  shipList = DOMTree.documentElement
  xmldata = shipList.getElementsByTagName('Inventory')
  
  if (xmldata == []):
    #no inventory, exit
    return False
  
  for ship in xmldata[0].getElementsByTagName('ship'):
    for masterShip in gv.ShipClassList:
      if (int(ship.getAttribute('index')) == masterShip.index):
        masterShip.numOwned = int(ship.getAttribute('numOwned'))
        break
  return True

def ReadMarData(filename):
  if (not filename):
    return False
  
  try:
    DOMTree = xml.dom.minidom.parse(filename)
  except Exception,errorMsg:
    return errorMsg
    
  marList = DOMTree.documentElement
  mars = marList.getElementsByTagName('MAR')
  index = 0
  for mar in mars:
    newRecord = dataStruct.MarRecord()
    newRecord.marIndex = index
    index += 1
    xmldata = mar.getElementsByTagName('MAR_Number')
    newRecord.marNumber = int(xmldata[0].childNodes[0].data)
    xmldata = mar.getElementsByTagName('MAR_Name')
    newRecord.marName = xmldata[0].childNodes[0].data
    xmldata = mar.getElementsByTagName('MAR_Text')
    newRecord.marText = xmldata[0].childNodes[0].data
    
    xmldata = mar.getElementsByTagName('MAR_Summary')
    if (xmldata != []):
      newRecord.marSummary = xmldata[0].childNodes[0].data
    else:
      newRecord.marSummary = newRecord.marText
    
    xmldata = mar.getElementsByTagName('MAR_ValueRequired')
    if (xmldata != []):
      newRecord.valueRequired = True
    else:
      newRecord.valueRequired = False
    
    xmldata = mar.getElementsByTagName('MAR_intValue1')
    if (xmldata != []):
      newRecord.intValue1 = int(xmldata[0].childNodes[0].data)

    xmldata = mar.getElementsByTagName('MAR_intValue2')
    if (xmldata != []):
      newRecord.intValue2 = int(xmldata[0].childNodes[0].data)

    xmldata = mar.getElementsByTagName('MAR_strValue1')
    if (xmldata != []):
      newRecord.strValue1 = xmldata[0].childNodes[0].data
      
    xmldata = mar.getElementsByTagName('MAR_strValue2')
    if (xmldata != []):
      newRecord.strValue2 = xmldata[0].childNodes[0].data
    
    gv.MarList.append(newRecord)
  return True
  
def SaveShipInventoryData(filename=None):
  if (not filename):
    return
  else:
    ship = dataStruct.ShipRecord()
    savefile = file(filename, 'w')
    savefile.write('<?xml version="1.0" encoding="UTF-8"?>\n')
    savefile.write('<FirestormShipInventory>\n')
    savefile.write('\t<Inventory>\n')
    for ship in gv.ShipClassList:
      savefile.write('\t\t<ship index="{0}" numOwned="{1}" />\n'.format(ship.index, ship.numOwned))
    savefile.write('\t</Inventory>\n')
    savefile.write('</FirestormShipInventory>\n')
    savefile.close()
  return
  
def SaveShipClassData(filename=None):
  if (not filename):
    return False
  else:
    ship = dataStruct.ShipRecord()
    savefile = file(filename, 'w')
    savefile.write('<?xml version="1.0" encoding="UTF-8"?>\n')
    savefile.write('<FirestormShipClasses>\n')
    ship = dataStruct.ShipRecord()
    for ship in gv.ShipClassList:
      savefile.write('<shipClass>\n')
      savefile.write('\t<shipIndex>%d</shipIndex>\n' % ship.index)
      if (ship.deleted_ship):
        savefile.write('\t<deleted_ship>True</deleted_ship>\n')
      else:
        savefile.write('\t<deleted_ship>False</deleted_ship>\n')
      savefile.write('\t<faction>%s</faction>\n' % ship.faction)
      savefile.write('\t<className>%s</className>\n' %ship.className)
      savefile.write('\t<designation>%s</designation>\n' % ship.designation)
      savefile.write('\t<baseCost>%d</baseCost>\n' % ship.baseCost)
      savefile.write('\t<secondaryCost>%d</secondaryCost>\n' % ship.secondaryCost)
      savefile.write('\t<squadronMin>%d</squadronMin>\n' % ship.squadronSizeMin)
      savefile.write('\t<squadronMax>%d</squadronMax>\n' % ship.squadronSizeMax)
      savefile.write('\t<classSize>%s</classSize>\n' % ship.classSize)
      savefile.write('\t<source>%s</source>\n' % ship.source)
      savefile.write('\t<DR>%d</DR>\n' % ship.DR)
      savefile.write('\t<CR>%d</CR>\n' % ship.CR)
      savefile.write('\t<HP>%d</HP>\n' % ship.HP)
      savefile.write('\t<MV>%d</MV>\n' % ship.MV)
      savefile.write('\t<TL>%d</TL>\n' % ship.TL)
      savefile.write('\t<CP>%d</CP>\n' % ship.CP)
      savefile.write('\t<AP>%d</AP>\n' % ship.AP)
      savefile.write('\t<PD>%d</PD>\n' % ship.PD)
      savefile.write('\t<SR>%d</SR>\n' % ship.SR)
      savefile.write('\t<MN>%d</MN>\n' % ship.MN)
      savefile.write('\t<WC>%d</WC>\n' % ship.WC)
      if (ship.cloakingField):
        savefile.write('\t<CloakingField>True</CloakingField>\n')
      else:
        savefile.write('\t<CloakingField>False</CloakingField>\n')
      savefile.write('\t<image>%s</image>\n' % ship.imageFilename)
      savefile.write('\t<notes>{0}</notes>\n'.format(ship.notes))
      savefile.write('\t<weaponsArray>\n')
      weapon = dataStruct.WeaponRecord()
      if (ship.weapons != []):
        for weapon in ship.weapons:
          savefile.write('\t\t<weapon ')
          savefile.write('weaponName="%s" ' % weapon.weaponName)
          savefile.write('category="%s" ' % weapon.category)
          savefile.write('weaponType="%s" ' % weapon.weaponType)
          savefile.write('arcDirection="%s" ' % weapon.arcDirection)
          savefile.write('arcRestriction="%s" ' % weapon.arcRestriction)
          if (weapon.hardpoint):
            savefile.write('hardpoint="%s" ' % weapon.hardpoint)
          savefile.write('rb1="%d" ' % weapon.rb1)
          savefile.write('rb2="%d" ' % weapon.rb2)
          savefile.write('rb3="%d" ' % weapon.rb3)
          savefile.write('rb4="%d" ' % weapon.rb4)
          savefile.write('rangeIncrement="%d" />\n' % weapon.rangeIncrement)
      savefile.write('\t</weaponsArray>\n')
      
      savefile.write('\t<maxHardpoints>%d</maxHardpoints>\n' % ship.maxHardPoints)
      if (ship.availableHardPoints != []):
        savefile.write('\t<availableHardpoints>\n')
        hpoint = dataStruct.HardpointRecord()
        for hpoint in ship.availableHardPoints:
          savefile.write('\t\t<hardpoint ')
          savefile.write('index="%d" ' % hpoint.index)
          savefile.write('numAvailable="%d" ' % hpoint.numAvailable)
          savefile.write('description="%s" ' % hpoint.description)
          savefile.write('cost="%d" ' % hpoint.cost)
          if (hpoint.intValue1):
            savefile.write('intValue1="%d" ' % hpoint.intValue1)
          if (hpoint.intValue2):
            savefile.write('intValue2="%d" ' % hpoint.intValue2)
          if (hpoint.intValue3):
            savefile.write('intValue3="%d" ' % hpoint.intValue3)
          if (hpoint.strValue1):
            savefile.write('strValue1="%s" ' % hpoint.strValue1)
          if (hpoint.strValue2):
            savefile.write('strValue2="%s" ' % hpoint.strValue2)
          savefile.write(' />\n')
        savefile.write('\t</availableHardpoints>\n')
      
      accomp = dataStruct.AccompanimentRecord()
      if (ship.accompanimentIncluded != []):
        savefile.write('\t<accompanimentAvailable>\n')
        for accomp in ship.accompanimentIncluded:
          savefile.write('\t\t<escort ')
          savefile.write('escortShipIndex="%d" ' % accomp.shipIndex)
          savefile.write('escortShipMax="%d" />\n' % accomp.numAllowed)
        savefile.write('\t</accompanimentAvailable>\n')
      
      mar = dataStruct.MarRecord()
      if (ship.MAR != []):
        savefile.write('\t<marList>\n')
        for mar in ship.MAR:
          savefile.write('\t\t<mar number="{0}" intValue1="{1}" intValue2="{2}" strValue1="{3}" strValue2="{4}" />\n'.format(mar.marNumber, mar.intValue1, mar.intValue2, mar.strValue1, mar.strValue2))
        savefile.write('\t</marList>\n')
      if (ship.upgrades != []):
        savefile.write('\t<upgradesList>\n')
        for upgrade in ship.upgrades:
          if (upgrade.xor != []):
            savefile.write('\t\t<upgrade index="{0}" cost="{1}" xor="{2}" color="{3}" />\n'.format(upgrade.index, upgrade.cost, upgrade.xor, upgrade.color))
          else:
            savefile.write('\t\t<upgrade index="{0}" cost="{1}" />\n'.format(upgrade.index, upgrade.cost))
        savefile.write('\t</upgradesList>\n')
      savefile.write('</shipClass>\n')
    savefile.write('</FirestormShipClasses>\n')
    savefile.close()
    return